(function(){
    var f = function(s, opt) {
        if(opt == null) {
            opt = {}
        }
        this.selector = s;
        this.elm = document.querySelector(s);
        this.toolbar = null;
        this.button = {};
        this.editor = null;
        this.opt = opt;
        return this.init();
    }
    var getStyle = function(a,b) {
        if(b==null) {
            b="";
        }
        if(window.getComputedStyle) {
            return window.getComputedStyle(a,b);
        } else if(document.defaultView && document.defaultView.getComputedStyle) {
            return document.defaultView.getComputedStyle(a,b);
        }
    }
    var traceStyle = function(o, t, prop) {
        window.addEventListener('resize', function() {
            var style = getStyle(o);
            t.style[prop] = style[prop];
        }, false);

        window.addEventListener('load', function() {
            window.dispatchEvent(new Event('resize'));
        }, false);
    }

    f.prototype = {
        init: function() {
            this.setup();
            return this;
        },
        setup: function() {
            this.editor = document.createElement('div');
            this.editor.contentEditable = true;
            this.editor.classList.add('be-editor');
            traceStyle(this.elm, this.editor, "width");
            traceStyle(this.elm, this.editor, "min-height");
            traceStyle(this.elm, this.editor, "text-align");

            //ツールバー
            this.toolbar = document.createElement('div');
            this.toolbar.classList.add('be-toolbar');

            //ツールバーのボタン
            this.button.bold = document.createElement('button');
            this.button.bold.classList.add('be-button');
            this.button.bold.classList.add('be-button-bold');
            this.button.bold.innerText = "B";

            this.button.italic = document.createElement('button');
            this.button.italic.classList.add('be-button');
            this.button.italic.classList.add('be-button-italic');
            this.button.italic.innerText = "I";

            this.button.underline = document.createElement('button');
            this.button.underline.classList.add('be-button');
            this.button.underline.classList.add('be-button-underline');
            this.button.underline.innerText = "U";

            if(this.opt.button) {
                for(var i in this.opt.button) {
                    this.opt.button[i].classList.add('be-button-extra');
                    this.button[i] = this.opt.button[i];
                }
            }

            this.elm.parentNode.insertBefore(this.editor, this.elm);
            this.elm.parentNode.insertBefore(this.toolbar, this.editor);
            this.elm.style.display = 'none';

            for(var i in this.button) {
                this.toolbar.appendChild(this.button[i]);
            }

            this.setEvent();
            this.bindEditor();
        },
        setEvent: function() {
            var self = this;
            var editor = this.editor;
            this.editor.addEventListener("keydown", function(e) {
                var EnterKey = 13;
                if (e.keyCode == EnterKey) {
                    var sel = window.getSelection();
                    var range;
                    var r = document.createTextNode("\r");
                    var node = document.createElement("br");
                    if (sel.rangeCount == 0) {
                      return;
                    }
                    range = sel.getRangeAt(0);
                    range.insertNode(r);
                    range.insertNode(node);
                    range.setStartAfter(r);
                    range.setEndAfter(r);
                    sel.removeAllRanges();
                    sel.addRange(range);
                    e.preventDefault();
                }
            }, false);

            this.editor.addEventListener("keyup", function(e) {
                self.bindValue();
            }, false);

            this.editor.addEventListener("paste", function(e) {
                var sel = window.getSelection();
                var cursol = sel.focusOffset;
                var text = e.clipboardData.getData("text");
                var node;
                var line=[];
                var node1,node2,node3;
                range = sel.getRangeAt(0);
                text = text.replace(/\r\n\r|\r\n|\n/g, "\r");
                line = text.split("\r");
                if(range.startOffset != range.endOffset) {
                    range.deleteContents();
                }
                for(let i = 0; i < line.length; i++) {
                    if( i < line.length-1) {
                        node2 = document.createTextNode("\r");
                        range.insertNode(node2);
                        node1 = document.createElement("br");
                        range.insertNode(node1);
                    }
                    node3 = document.createTextNode(line[i]);
                    range.insertNode(node3);

                    range.setStartAfter(node1||node3);
                    range.setEndAfter(node1||node3);
                }

                sel.removeAllRanges();
                sel.addRange(range);

                self.bindValue();
                e.preventDefault();
            }, false);

            //太字
            this.toolbar.querySelector(".be-button-bold").addEventListener("click", function(e) {
                document.execCommand("bold", false);
                var sel = window.getSelection();
                var range, tag, node;
                if (sel.rangeCount == 0) {
                  return;
                }
                range = sel.getRangeAt(0);
                tag = editor.querySelectorAll('b');
                //polyfill for IE11
                node = Array.prototype.slice.call(tag, 0);
                node.forEach(function(elm) {
                    var newNode = document.createElement("strong");
                    var parent = elm.parentNode;
                    newNode.innerHTML = elm.innerHTML;
                    parent.replaceChild(newNode, elm);

                    range.setStartBefore(newNode);
                    range.setEndAfter(newNode);
                    sel.removeAllRanges();
                    sel.addRange(range);
                });

                self.bindValue();
                e.preventDefault();
            }, false);

            //斜体
            this.toolbar.querySelector(".be-button-italic").addEventListener("click", function(e) {
                document.execCommand("italic", false);
                var sel = window.getSelection();
                var range, tag, node;
                if (sel.rangeCount == 0) {
                  return;
                }
                range = sel.getRangeAt(0);
                tag = editor.querySelectorAll('i');
                //polyfill for IE11
                node = Array.prototype.slice.call(tag, 0);
                node.forEach(function(elm) {
                    var newNode = document.createElement("em");
                    var parent = elm.parentNode;
                    newNode.innerHTML = elm.innerHTML;
                    parent.replaceChild(newNode, elm);

                    range.setStartBefore(newNode);
                    range.setEndAfter(newNode);
                    sel.removeAllRanges();
                    sel.addRange(range);
                });

                self.bindValue();
                e.preventDefault();
            }, false);
            //下線
            this.toolbar.querySelector(".be-button-underline").addEventListener("click", function(e) {
                document.execCommand("underline", false);
                var sel = window.getSelection();
                var range, tag, node;
                if (sel.rangeCount == 0) {
                  return;
                }
                range = sel.getRangeAt(0);
                tag = editor.querySelectorAll('u');
                //polyfill for IE11
                node = Array.prototype.slice.call(tag, 0);
                node.forEach(function(elm) {
                    var newNode = document.createElement("span");
                    var parent = elm.parentNode;
                    // newNode.classList.add('underline');
                    newNode.innerHTML = elm.innerHTML;
                    newNode.style.textDecoration = "underline";
                    parent.replaceChild(newNode, elm);

                    range.setStartBefore(newNode);
                    range.setEndAfter(newNode);
                    sel.removeAllRanges();
                    sel.addRange(range);
                });

                self.bindValue();

                e.preventDefault();
            }, false);
        },
        bindEditor: function() {
            this.editor.innerHTML = this.elm.value;
        },
        bindValue: function() {
            this.elm.value = this.editor.innerHTML;
            this.elm.dispatchEvent(new Event('change', {"bubbles":true, "cancelable":false}));
        }
    }
    if(!window.blockEditor) {
        window.blockEditor = f;
    }

    var init = 0;
    window.addEventListener('DOMContentLoaded', function() {
        if(init == 0) {
            init = 1;
            window.dispatchEvent(new Event('blockEditorReady', {"bubbles":true, "cancelable":false}));
        }
    });
    window.addEventListener('load', function() {
        if(init == 0) {
            init = 1;
            window.dispatchEvent(new Event('blockEditorReady', {"bubbles":true, "cancelable":false}));
        }
    });
})();
