"use strict";
(function($) {
    $(".prop_use_0").on('change init', function() {
        if($(this).prop('checked')) {
            var checked = $(".prop_use_0:checked").val();

            if (checked == 1) {
                $('._simpleOption_pc').hide();
                $('._detailOption_pc').show();
            } else {
                $('._simpleOption_pc').show();
                $('._detailOption_pc').hide();
            }
        }
    }).trigger('init');

    $(".prop_use_1").on('change init', function() {
        if($(this).prop('checked')) {
            var checked = $(".prop_use_1:checked").val();

            if (checked == 1) {
                $('._simpleOption_sp').hide();
                $('._detailOption_sp').show();
            } else {
                $('._simpleOption_sp').show();
                $('._detailOption_sp').hide();
            }
        }
    }).trigger('init');

    /**
     * 各設定画面内のPC/SP切り替え
     */
    var showSettingDevice = function(type, device) {
        if (device == 'pc') {
            type.find('.viewpc').show();
            type.find('.viewsp').hide();
        } else if (device == 'sp') {
            type.find('.viewpc').hide();
            type.find('.viewsp').show();
        }
    }

    $('.deviceTabMenu a').off('click').on('click', function(e) {
        if ($(this).hasClass('active')) {
            return;
        }

        var prefix = $(this).data('prefix');
        var p = $(document);
        var d = $(this).data('device');
        if (prefix) {
            p = $(this).parents('[id^=' + prefix + ']');
        }
        showSettingDevice(p, d);

        p.find('.deviceTabMenu a').removeClass('active hover');
        $(this).addClass('active');

        e.preventDefault();
        e.stopPropagation();
    });

    $('[name=unit_sync]').on('change init', function(e) {
        if($(this).prop('checked')) {
            var sync = $('[name=unit_sync]:checked').val() == 1;
            var bool=true;

            if(sync) {
                if(e.type != 'init') {
                    bool = confirm("リンク状態で保存を行うとSPの設定はPCの設定で上書きされますが宜しいですか");
                }
                if(bool) {
                    $('.deviceTabMenu a:eq(0)').trigger('click');
                    $('.deviceTabMenu a:eq(0) span').html('PC・Tablet・SP');
                    $('.deviceTabMenu li:eq(1)').hide();
                } else {
                    $('[name=unit_sync][value=0]').prop('checked', true);
                }
            } else {
                $('.deviceTabMenu a:eq(0) span').text('PC・Tablet');
                $('.deviceTabMenu li:eq(1)').show();
            }
        }
    }).trigger('init');

    // //詳細オプションチェック
    // $('#prop_use_0').on('change init', function() {
    //     $('#prop_use_1').prop('checked', $(this).prop('checked')).trigger('change');
    // }).trigger('init');
    //
    // //スマホ独自設定チェック
    // $('#option_extend').on('change init', function() {
    //     if ($(this).prop('checked')) {
    //         if ($('#prop_use_1').prop('checked')) {
    //             $('._simpleOption_sp').hide();
    //             $('._detailOption_sp').show();
    //         } else {
    //             $('._simpleOption_sp').show();
    //             $('._detailOption_sp').hide();
    //         }
    //         $('._viewspcopy').show();
    //     } else {
    //         $('._simpleOption_sp, ._detailOption_sp, ._viewspcopy').hide();
    //     }
    // }).trigger('init');
})(jQuery);

/******************
 * 以下ユニット用JS
 ******************/
function copySP() {
    // CKEDITOR.instances.body_sp.setData(CKEDITOR.instances.body.getData());
    spE.elm.value = pcE.elm.value;
    spE.bindEditor();
}

/**
 * 入力エリア背景色変更
 */
(function($) {
    // $('#inputbg').on('change', function() {
    //     var checked = $(this).prop("checked");
    //     bCookie.setCookie('btxtsbg', checked, 365);
    //     if (checked) {
    //         $('#body').parent().addClass('bgdark');
    //     } else {
    //         $('#body').parent().removeClass('bgdark');
    //     }
    // });
    //
    // if (bCookie.getCookie('btxtsbg') == 'true') {
    //     $('#inputbg').trigger('click');
    // }
    //
    // $('#inputbgsp').on('change', function() {
    //     var checked = $(this).prop("checked");
    //     bCookie.setCookie('btxtsbgsp', checked, 365);
    //     if (checked) {
    //         $('#body_sp').parent().addClass('bgdark');
    //     } else {
    //         $('#body_sp').parent().removeClass('bgdark');
    //     }
    // });
    //
    // if (bCookie.getCookie('btxtsbgsp') == 'true') {
    //     $('#inputbgsp').trigger('click');
    // }
})(jQuery);

/**
 * プレビュー処理
 */
(function($) {
    $(function() {
        var outer = $("#prevOuter");
        //var area = $("#prevInner");
        var previewRefresh = function(prefix) {
            if (prefix == null) {
                prefix = "";
            }
            outer = $("#prevOuter" + prefix);

            //text
            var text = $("#body" + prefix).val();
            // align
            var align = $("[name=align" + prefix +"]:checked").val();
            //css
            var ffamily = $("#ffamily" + prefix).val();
            // var fcolor = $("#fcolor" + prefix).val();
            //var lineHeight = $("#lineHeight" + prefix).val();
            var letterSpacing = $("#letterSpacing" + prefix).val();
            var shadowX = $("#shadow_x" + prefix).val();
            var shadowY = $("#shadow_y" + prefix).val();
            var shadowBlur = $("#shadow_blur" + prefix).val();
            var shadowColor = $("#shadow_color" + prefix).val(); //rgba
            var textShadow = "";
            var width = "";
            if (!isNaN(parseFloat(shadowX)) && isFinite(shadowX) && !isNaN(parseFloat(shadowY)) && isFinite(shadowY) && !isNaN(parseFloat(shadowBlur)) && isFinite(shadowBlur) && shadowColor.match(/^[\d\.]+,[\d\.]+,[\d\.]+,[\d\.]+$/)) {
                if (0 != ~~ shadowX || 0 != ~~ shadowY || 0 < ~~ shadowBlur) {
                    textShadow = shadowX + "px " + shadowY + "px " + shadowBlur + "px rgba(" + shadowColor + ")";
                }
            }
            // if (!isNaN(parseFloat(lineHeight)) && isFinite(lineHeight)) {
            //     lineHeight += "em";
            // }
            if (!isNaN(parseFloat(letterSpacing)) && isFinite(letterSpacing)) {
                letterSpacing += "em";
            }

            outer.css({
                fontFamily: fonts[ffamily],
                //lineHeight: lineHeight,
                letterSpacing: letterSpacing,
                textShadow: textShadow
            });
            if (prefix == "_sp") {
                prefix = "_1";
            } else {
                prefix = "_0";
            }

            if(prefix == "_0" || extend) {
                if(0 < ~~($("#border_width_0").val())*2) {
                    width = "calc(100% - "+(~~($("#border_width_0").val())*2)+"px)";
                }
            } else {
                if(0 < ~~($("#border_width_1").val())*2) {
                    width = "calc(100% - "+(~~($("#border_width_1").val())*2)+"px)";
                }
            }

            //ボーダーある場合はボーダー分をwidthから引く
            outer.css({
                paddingRight: (prefix == "_0" || extend) ? $("#padding_right_0").val() : $("#padding_right_1").val(),
                paddingLeft: (prefix == "_0" || extend) ? $("#padding_left_0").val() : $("#padding_left_1").val(),
                width: width
            });

            // if(fcolor != "") {
            //     fcolor = "rgba("+fcolor+")";
            // }
            outer.find('.be-editor').css({
                textAlign: align
                // color: fcolor
            });
        }

        $("#type_text").on("change", function(e) {
            var sync = $('[name=unit_sync]:checked').val() == 1;
            if (sync) {
                // copySP();
            }
        });
        //
        // CKEDITOR.on('instanceReady', function(){
        //     CKEDITOR.instances.body_sp.on('key', function(e){
        //         if(chain) {
        //             $('#unit_sync').trigger('click');
        //         }
        //     });
        // });

        $("#fcolor, #lineHeight,#letterSpacing,#shadow_y,#shadow_x,#shadow_color,#shadow_blur").on("change pickerChange sliderChange onsync", function(e) {
            var sync = $('[name=unit_sync]:checked').val() == 1;
            previewRefresh();
            if (sync) {
                $("#" + e.target.id + "_sp").val($("#" + e.target.id).val()).trigger("change");
                console.log($("#" + e.target.id + "_sp").val());
                if (e.type == "pickerChange" || e.type == "onsync") {
                    if(e.target.id == "fcolor") {
                        $("#fcolor_sp").next().get(0).color.active.val("hex", $("#fcolor").next().get(0).color.active.val("hex"));
                    } else {
                        $("#shadow_color_sp").next().get(0).color.active.val("hex", $("#shadow_color").next().get(0).color.active.val("hex"));
                    }
                }
                previewRefresh("_sp");
            }
        });

        $("#fcolor_sp,#lineHeight_sp,#letterSpacing_sp,#shadow_y_sp,#shadow_x_sp,#shadow_color_sp,#shadow_blur_sp").on("change pickerChange sliderChange", function(e) {
            previewRefresh("_sp");
        });
        $("#ffamily").on("change", function(e) {
            previewRefresh();
        });
        $("#ffamily_sp").on("change", function(e) {
            previewRefresh("_sp");
        });
        $("[name=align]").on("change", function(e) {
            previewRefresh();
        });
        $("[name=align_sp]").on("change", function(e) {
            previewRefresh("_sp");
        });
        $("#fsize").on("blur", function(e) {
            previewRefresh();
        });
        $("#fsize_sp").on("blur", function(e) {
            previewRefresh("_sp");
        });

        var target = ["border_width", "padding_top", "padding_right", "padding_bottom", "padding_left"];
        for(var no = 0; no < 2; no++) {
            for(var i in target) {
                var s = target[i];
                (function(no){
                    $("#"+s+"_"+no).on("blur", function(e) {
                        if(no == 0) {
                            previewRefresh();
                            if (chain) {
                                previewRefresh("_sp");
                            }
                        } else {
                            previewRefresh("_sp");
                        }
                    });
                })(no);
            }
        }

        $("#option_extend").on("change", function(e) {
            previewRefresh("_sp");
        });

        previewRefresh();
        previewRefresh("_sp");
    });

})(jQuery);

/**
 * スライダー
 */
(function(){
    new InputSlider("#bInputRange1", { min: 1, decimal: 1 });
    new InputSlider("#bInputRange2", { min: 0, decimal: 1 });
    new InputSlider("#bInputRange3", { min: -20, max: 20 });
    new InputSlider("#bInputRange4", { max: 20 });
    new InputSlider("#bInputRange5", { min: -20, max: 20 });
    sp_slider1 = new InputSlider("#bInputRange1_sp", { min: 1, decimal: 1 });
    sp_slider2 = new InputSlider("#bInputRange2_sp", { min: 0, decimal: 1 });
    sp_slider3 = new InputSlider("#bInputRange3_sp", { min: -20, max: 20 });
    sp_slider4 = new InputSlider("#bInputRange4_sp", { max: 20 });
    sp_slider5 = new InputSlider("#bInputRange5_sp", { min: -20, max: 20 });
})();

/**
 * loadイベント
 */
(function($){
    if (viewmode == 'sp') {
        if($("[name=unit_sync]:checked").val()==0) {
            $(".deviceTabMenu").find('[data-device=sp]').trigger('click');
        }
    }
    $(window).on("load", function(){
        FontSelector.setOpenHandler(".bSelecterBtn", {baseurl: bingotopurl,
            callback: function(code, family, style) {
                var self = $(FontSelector.target);
                var name = document.createElement('p');
                var delLink = document.createElement('a');
                var sync = self.data('sync');
                var stylesArray = style.split(";");
                var fontStyle = "";
                $(name).addClass('selectedFontFamily').text(family);
                $(delLink).text('×').addClass('_fontClear').attr({href: 'javascript:void(0);'}).data('sync', sync);

                self.next().remove();
                $(name).append(delLink);
                self.after(name);

                $(sync).val(code);
                FontSelector.reload();

                for(var i = 0; i < stylesArray.length; i++){
                    var m = stylesArray[i].match(/^ *font\-family *: *(.*)/);
                    if(m) {
                        fontStyle = m[1];

                        break;
                    }
                }
                if(sync == "[name=ffamily]") {
                    $('#prevOuter').css({'font-family': fontStyle});
                } else {
                    $('#prevOuter_sp').css({'font-family': fontStyle});
                }
            }
        });

        $("#BTNsave").on("click", function(){
            sp_slider1.disable(false);
            sp_slider2.disable(false);
            sp_slider3.disable(false);
            sp_slider4.disable(false);
            sp_slider5.disable(false);
        });

        $('#page-unit-detail').on('click', '._fontClear', function() {
            var sync = j$(this).data('sync');
            j$(sync).val('');
            $(this).parent().remove();

            if(sync == "[name=ffamily]") {
                $('#prevOuter').css({'font-family': ''});
            } else {
                $('#prevOuter_sp').css({'font-family':''});
            }
        });

        // CKEDITOR.on('instanceReady', function(e) {
        //     if(e.editor.name == "body_sp") {
        //         $("#unit_sync").trigger("init");
        //     }
        // });
    });


})(jQuery);
