<?php
/**
 * @copyright 2018 Shift Tech Inc All Rights Reserved.
 * @author Shift Tech inc.<https://www.shift-tech.jp/>
 */
require_once (LIB_PATH.'/common/unitCommon.php');

class extTypewriter extends unitCommon
{
    //------ ユニット毎に必ず設定しなくてはならない変数 -------//
    var $_table = "extunit_typewriter";        //公開用テーブル名
    var $_tmptable = "extunit_typewriter_tmp";    //下書き用テーブル名
    var $columns = array(
        array("column"=>"pageu_code","conv"=>"n","tags"=>false),
        array("column"=>"type_text","conv"=>"KV","tags"=>true),
        array("column"=>"type_text_sp","conv"=>"KV","tags"=>true),
        array("column"=>"type_speed","conv"=>"n","tags"=>false),
        array("column"=>"type_interval","conv"=>"n","tags"=>false),
        array("column"=>"type_pause","conv"=>"n","tags"=>false),
        array("column"=>"type_loop","conv"=>"n","tags"=>false),
        array("column"=>"type_effect_type","conv"=>"n","tags"=>false),
        array("column"=>"type_effect_duration","conv"=>"n","tags"=>false),
        array("column"=>"align","conv"=>"a","tags"=>false),
        array("column"=>"fsize","conv"=>"a","tags"=>false),
        array("column"=>"fcolor","conv"=>"a","tags"=>false),
        array("column"=>"ffamily", "conv" => "KVa", "tags" => false),
        array("column"=>"shadow_x", "conv" => "n", "tags" => false),
        array("column"=>"shadow_y", "conv" => "n", "tags" => false),
        array("column"=>"shadow_blur", "conv" => "n", "tags" => false),
        array("column"=>"shadow_color", "conv" => "KVa", "tags" => false),
        array("column"=>"letterSpacing", "conv" => "n", "tags" => false),
        array("column"=>"align_sp","conv"=>"a","tags"=>false),
        array("column"=>"fsize_sp","conv"=>"a","tags"=>false),
        array("column"=>"fcolor_sp","conv"=>"a","tags"=>false),
        array("column"=>"ffamily_sp", "conv" => "KVa", "tags" => false),
        array("column"=>"shadow_x_sp", "conv" => "n", "tags" => false),
        array("column"=>"shadow_y_sp", "conv" => "n", "tags" => false),
        array("column"=>"shadow_blur_sp", "conv" => "n", "tags" => false),
        array("column"=>"shadow_color_sp", "conv" => "KVa", "tags" => false),
        array("column"=>"letterSpacing_sp", "conv" => "n", "tags" => false),

        array("column"=>"use_sp_flg","conv"=>"n","tags"=>false),
        array("column"=>"use_pc_flg","conv"=>"n","tags"=>false),
        array("column"=>"bg_color","conv"=>"n","tags"=>false),        //背景色
        array("column"=>"bdr_type","conv"=>"n","tags"=>false),        //ボーダー
        array("column"=>"btm_padding","conv"=>"n","tags"=>false),      //下方スペース
        array("column"=>"bg_color_sp","conv"=>"n","tags"=>false),     //背景色
        array("column"=>"bdr_type_sp","conv"=>"n","tags"=>false),    //ボーダー
        array("column"=>"btm_padding_sp","conv"=>"n","tags"=>false),   //下方スペース
        array("column"=>"extra_class", "conv" => "as", "tags" => false),  //追加クラス
        array("column"=>"option_extend", "conv" => "n", "tags" => false),  //デザインオプションの継承
        array("column"=>"anchor_text", "conv" => "KVa", "tags" => false),  //デザインオプションの継承
        array("column"=>"unit_sync", "conv" => "n", "tags" => false),

        array("column"=>"animatecsshelp", "conv" => "KVa", "tags" => false),
        array("column"=>"animatecsshelp_speed", "conv" => "n", "tags" => false),
        array("column"=>"animatecsshelp_delay", "conv" => "n", "tags" => false),
        array("column"=>"animatecsshelp_timing", "conv" => "n", "tags" => false),
    );

    function __construct()
    {
        unitCommon::__construct();
    }

    //出力データセット処理（必須）
    function setDisplayData() {
        $this->_data = $this->getDetail();
        $props = $this->getProp($this->_pageu_code);
        $this->_view->assign('isSP', 0);
        if(!empty($this->_data)) {
            if($this->_data['animatecsshelp']!="") {
                $this->_data['extra_class'] .= " attach_anim attach_".$this->_data['animatecsshelp'];
            }

            if ($this->checkSP()) {
                if($this->_data['unit_sync'] == 1) {
                    //PCを継承時はPCパラメータで上書きしておく
                    $props[1] = $props[0];
                }
                //スマホ時
                if(is_array($props) && isset($props[1])) {
                    $this->_data = array_merge($this->_data, $props[1]);
                }

                if ($this->_data['unit_sync'] != 1) {
                    $this->_data['type_text'] = $this->_data['type_text_sp'];
                    $this->_data['align'] = $this->_data['align_sp'];
                    $this->_data['fsize'] = $this->_data['fsize_sp'];
                    $this->_data['fcolor'] = $this->_data['fcolor_sp'];
                    $this->_data['ffamily'] = $this->_data['ffamily_sp'];
                    $this->_data['letterSpacing'] = $this->_data['letterSpacing_sp'];
                    $this->_data['shadow_x'] = $this->_data['shadow_x_sp'];
                    $this->_data['shadow_y'] = $this->_data['shadow_y_sp'];
                    $this->_data['shadow_blur'] = $this->_data['shadow_blur_sp'];
                    $this->_data['shadow_color'] = $this->_data['shadow_color_sp'];
                }
                $this->_view->assign('isSP', 1);
            } else {
                if(is_array($props) && isset($props[0])) {
                    $this->_data = array_merge($this->_data, $props[0]);
                }
            }

            $unitStyle = $this->createUnitStyle($this->_data);
            if(is_array($unitStyle) && 0 < count($unitStyle)) {
                $this->_data['unitStyle'] = implode(' ', $unitStyle);
            }
            $this->_data['unitAttr']=array('style'=>array());
            if($this->_data['animatecsshelp']!="" && preg_match('/.+Out.*/', $this->_data['animatecsshelp'])) {
                $this->_data['unitAttr']['style'][] = "visibility: visible;";
            }
            if($this->_data['animatecsshelp_speed']!="" && is_numeric($this->_data['animatecsshelp_speed'])) {
                $this->_data['unitAttr']['style'][] = "animation-duration: ".$this->_data['animatecsshelp_speed']."ms;";
            }
            if($this->_data['animatecsshelp_delay']!="" && is_numeric($this->_data['animatecsshelp_delay'])) {
                $this->_data['unitAttr']['style'][] = "animation-delay: ".$this->_data['animatecsshelp_delay']."ms;";
            }
            if($this->_data['animatecsshelp_timing']!="" && is_numeric($this->_data['animatecsshelp_timing'])) {
                $this->_data['unitAttr']['data-offset'][] = $this->_data['animatecsshelp_timing'];
            }

            //テキストスタイル
            $color = null;
            if($this->_data['fcolor'] != "") {
                $color = "rgba(".$this->_data['fcolor'].")";
            }
            $textStyle = $this->createTextStyle(
                $this->_data['ffamily'],
                $this->_data['fsize'],
                $color,
                $lineHeight=null,
                $this->_data['letterSpacing'],
                $weight = null,
                $textAlign = null,
                $this->_data['shadow_x'],
                $this->_data['shadow_y'],
                $this->_data['shadow_blur'],
                $this->_data['shadow_color']
            );

            if(is_array($textStyle) && 0 < count($textStyle)) {
                $this->_data['textStyle'] = implode(' ', $textStyle);
            }

            //共通プロパティ（余白とか）
            $unitStyle = $this->createUnitStyle($this->_data);
            $unitStyle[] = "line-height: 1.4;";
            if($this->_data['align'] == "center" || $this->_data['align'] == "right") {
                $unitStyle[] = "text-align:".$this->_data['align'].";";
            }
            if(is_array($unitStyle) && 0 < count($unitStyle)) {
                $this->_data['unitStyle'] = implode(' ', $unitStyle);
            }

            $this->_data['class'] = $this;

            //IEの時はpolyfill
            if(!empty($_SESSION['MSIE'])) {
                $this->addLoadJs(BINGOTOPURL.'/usr-data/extunits'.$this->_dir.'/es6-promise.min.js');
                $this->addLoadJs(BINGOTOPURL.'/usr-data/extunits'.$this->_dir.'/es6-promise.auto.min.js');
            }

            if($this->_data['type_effect_type']) {
                $this->_data['type_effect_type'] = "fade";
            }

            $this->_view->assign('isAdmin', $this->isAdmin());
        }

        return $this->_data;
    }

    /*
     * DBより保存データ取得
     * 改変可能
     */
    function getDetail() {
        $rtn =  null;
        $sql = "select * from ".$this->getTbl()." where pageu_code = ?";
        if(isset($this->_pageu_code)&&is_numeric($this->_pageu_code)) {
            $result = $this->db->prepare($sql,$this->_pageu_code);
            if($result){
                $rtn = $result->fetchRow(DB_FETCHMODE_ASSOC);
            }
        }
        return $rtn;
    }


    function setDefault()
    {
        $this->_data = $this->getDetail();
        $this->_data = $this->getProperty4device($this->_data);
        if ($this->_data) {
            $this->_form->setDefaults($this->_data);
        } else {
            $this->_data['type_interval'] = 1;
            $this->_data['align'] = 'left';
            $this->_data['shadow_x'] = '0';
            $this->_data['shadow_y'] = '0';
            $this->_data['shadow_blur'] = '0';
            $this->_data['shadow_color'] = '0,0,0,0.8';
            $this->_data['align_sp'] = 'left';
            $this->_data['shadow_x_sp'] = '0';
            $this->_data['shadow_y_sp'] = '0';
            $this->_data['shadow_blur_sp'] = '0';
            $this->_data['shadow_color_sp'] = '0,0,0,0.8';
            $this->_data['unit_sync'] = 1;
        }
        $this->_form->setDefaults($this->_data);
    }

    /**
     * フォームエレメントの作成.
     */
    public function setElements()
    {
        $this->_form->addElement('hidden', 'pageu_code', $this->_pageu_code, array('id' => 'pageu_code'));
        $this->_form->addElement('textarea', 'type_text', null, array('id' => 'type_text', 'class' => 'type_text', 'style'=>'text-align:'.$this->_data['align']));
        $this->_form->addElement('textarea', 'type_text_sp', null, array('id' => 'type_text_sp', 'class' => 'type_text', 'style'=>'text-align:'.$this->_data['align_sp']));
        //タイプ速度
        $this->_form->addElement('text', 'type_speed', null, array('id' => 'type_speed', 'class' => 'num numL', 'style' => 'ime-mode:disabled;', 'placeholder' => 300));
        //タイプ速度ランダム
        $this->_form->addElement('advcheckbox', 'type_interval', null, 'ランダム', array('id' => 'type_interval'), array(0,1));
        //停止時間
        $this->_form->addElement('text', 'type_pause', null, array('id' => 'type_pause', 'class' => 'num numL', 'style' => 'ime-mode:disabled;', 'placeholder' => 2000));
        //ループフラグ
        $this->_form->addElement('advcheckbox', 'type_loop', null, 'くり返す', array('id' => 'type_loop'), array(0, 1));
        //フェード
        $this->_form->addElement('advcheckbox', 'type_effect_type', null, '使用する', array('id' => 'type_effect_type'), array(0, 1));
        //フェード時間
        $this->_form->addElement('text', 'type_effect_duration', null, array('id' => 'type_effect_duration', 'class' => 'num numL', 'style' => 'ime-mode:disabled;', 'placeholder' => 300));

        //整列
        $this->_form->addGroup(array(
            $this->_form->createElement('radio', null, null, '左', 'left', array('labelClass' => 'radioBtn alignL')),
            $this->_form->createElement('radio', null, null, '中央', 'center', array('labelClass' => 'radioBtn alignC')),
            $this->_form->createElement('radio', null, null, '右', 'right', array('labelClass' => 'radioBtn alignR'))
        ), 'align', '', '');
        $this->_form->addGroup(array(
            $this->_form->createElement('radio', null, null, '左', 'left', array('labelClass' => 'radioBtn alignL')),
            $this->_form->createElement('radio', null, null, '中央', 'center', array('labelClass' => 'radioBtn alignC')),
            $this->_form->createElement('radio', null, null, '右', 'right', array('labelClass' => 'radioBtn alignR'))
        ), 'align_sp', '', '');

        //文字サイズ
        $this->_form->addElement('text', 'fsize', null, array('id' => 'fsize', 'class' => 'num numL', 'style' => 'ime-mode:disabled;'));
        $this->_form->addElement('text', 'fsize_sp', null, array('id' => 'fsize_sp', 'class' => 'num numL', 'style' => 'ime-mode:disabled;'));
        //文字色
        $this->_form->addElement('text', 'fcolor', null, array('id' => 'fcolor', 'class' => 'color', 'style' => 'ime-mode:disabled; display:none;'));
        $this->_form->addElement('text', 'fcolor_sp', null, array('id' => 'fcolor_sp', 'class' => 'color', 'style' => 'ime-mode:disabled; display:none;'));
        //行間
        // $this->_form->addElement('text', 'lineHeight', null, array('id' => 'lineHeight', 'class' => 'num', 'style' => 'ime-mode:disabled;'));
        // $this->_form->addElement('text', 'lineHeight_sp', null, array('id' => 'lineHeight_sp', 'class' => 'num', 'style' => 'ime-mode:disabled;'));
        //文字間
        $this->_form->addElement('text', 'letterSpacing', null, array('id' => 'letterSpacing', 'class' => 'num', 'style' => 'ime-mode:disabled;'));
        $this->_form->addElement('text', 'letterSpacing_sp', null, array('id' => 'letterSpacing_sp', 'class' => 'num', 'style' => 'ime-mode:disabled;'));
        //テキストフォント
        $this->_form->addElement('hidden', 'ffamily', null, array('id' => 'ffamily'));
        $this->_form->addElement('hidden', 'ffamily_sp', null, array('id' => 'ffamily_sp'));
        //テキストシャドウ
        $this->_form->addElement('text', 'shadow_x', null, array('id' => 'shadow_x', 'class' => 'num', 'style' => 'ime-mode:disabled;'));
        $this->_form->addElement('text', 'shadow_y', null, array('id' => 'shadow_y', 'class' => 'num', 'style' => 'ime-mode:disabled;'));
        $this->_form->addElement('text', 'shadow_blur', null, array('id' => 'shadow_blur', 'class' => 'num', 'style' => 'ime-mode:disabled;'));
        $this->_form->addElement('text', 'shadow_alpha', null, array('id' => 'shadow_alpha', 'class' => 'num', 'style' => 'ime-mode:disabled;'));
        $this->_form->addElement('text', 'shadow_color', null, array('id' => 'shadow_color', 'class' => 'color'));

        $this->_form->addElement('text', 'shadow_x_sp', null, array('id' => 'shadow_x_sp', 'class' => 'num', 'style' => 'ime-mode:disabled;'));
        $this->_form->addElement('text', 'shadow_y_sp', null, array('id' => 'shadow_y_sp', 'class' => 'num', 'style' => 'ime-mode:disabled;'));
        $this->_form->addElement('text', 'shadow_blur_sp', null, array('id' => 'shadow_blur_sp', 'class' => 'num', 'style' => 'ime-mode:disabled;'));
        $this->_form->addElement('text', 'shadow_alpha_sp', null, array('id' => 'shadow_alpha_sp', 'class' => 'num', 'style' => 'ime-mode:disabled;'));
        $this->_form->addElement('text', 'shadow_color_sp', null, array('id' => 'shadow_color_sp', 'class' => 'color'));

        //アンカー用テキスト
        $this->_form->addElement('text', 'anchor_text', null, array('id' => 'anchor_text', 'class' => 'txt'));
        $this->_form->addGroup(array(
            $this->_form->createElement('radio', null, null, _gettext('しない'), 1, array('labelClass'=>'radioBtn')),
            $this->_form->createElement('radio', null, null, _gettext('する'), 0, array('labelClass'=>'radioBtn')),
        ), 'unit_sync', '', '');

        $fontDB = new fontDB();
        $fonts = $fontDB->getUseFonts($isKey=true);
        $this->_view->addLoadFont($fonts);

        $this->_view->assign('font', $fonts[$this->_data['ffamily']]);
        $this->_view->assign('font_sp', $fonts[$this->_data['ffamily_sp']]);

        if(isset($_POST['animatecsshelp_speed'])) {
            $this->_data['animatecsshelp_speed'] = $_POST['animatecsshelp_speed'];
        }
        if(isset($_POST['animatecsshelp_delay'])) {
            $this->_data['animatecsshelp_delay'] = $_POST['animatecsshelp_delay'];
        }
        if(isset($_POST['animatecsshelp_timing'])) {
            $this->_data['animatecsshelp_timing'] = $_POST['animatecsshelp_timing'];
        }

        $this->_view->assign('data', $this->_data);
    }
    /**
     * フォーム入力エラーチェックの設定.
     */
    public function setRules()
    {
        $this->_form->applyFilter('__ALL__', 'trim');
        $this->_form->_submitValues = DataBase::ConvColumnVals($this->_form->_submitValues, $this->columns); //ルールに従った値変換、タグの除去
        $this->_form->setJsWarnings(_gettext('B_P00472'), '');

        $this->_form->addRule('pageu_code', _gettext('B_P00643'), 'required', null, $this->erchk);
        $this->_form->addRule('type_text', _gettext('B_P00210'), 'required', null, $this->erchk);

        $this->_form->addRule('fsize', _gettext('サイズには単位を含んでください。(使用可能な単位：px em rem %)'), 'regex', '/^\d+\.?(\d+)?(px|r?em|%)$/', $this->erchk);
        $this->_form->addRule('fsize_sp', _gettext('サイズには単位を含んでください。(使用可能な単位：px em rem %)'), 'regex', '/^\d+\.?(\d+)?(px|r?em|%)$/', $this->erchk);
    }

    /**
     * データ下書き保存処理.
     *
     * @param array $post 保存データ
     *
     * @return null|string エラー時=string
     */
    public function doSave($post)
    {
        if (!is_numeric($post['pageu_code'])) {
            return '・データの保存に失敗しました';
        }
        $unit_sync = $post['unit_sync'];
        $old_data = $this->getDetail();
        $record = null;
        foreach ($this->columns as $val) {
            if ($post[$val['column']] != null) {
                $record[$val['column']] = $post[$val['column']];
            } else {
                $record[$val['column']] = null;
            }
        }
        if($unit_sync == 1) {
            $record['bg_color_sp'] = $record['bg_color'];
            $record['bdr_type_sp'] = $record['bdr_type'];
            $record['btm_padding_sp'] = $record['btm_padding'];

            foreach($record as $k=>$v) {
                if(preg_match("/(.*)_sp$/", $k, $m)){
                    $record[$m[1].'_sp'] = $record[$m[1]];
                }
            }
        }
        $record['type_text'] = preg_replace('/<br>$|<br\/>$|<br \/>$|<br><\/br>$/', '', $record['type_text']);
        $record['type_text'] = preg_replace('/\r\n$|\r$|\n$/', '', $record['type_text']);
        $record['type_text'] = preg_replace('/$/', '', $record['type_text']);

        $record['type_text_sp'] = preg_replace('/<br>$|<br\/>$|<br \/>$|<br><\/br>$/', '', $record['type_text_sp']);
        $record['type_text_sp'] = preg_replace('/\r\n$|\r$|\n$/', '', $record['type_text_sp']);
        $record['type_text_sp'] = preg_replace('/$/', '', $record['type_text_sp']);




        $txt = $record['type_text'];

        $aa = explode("<br>", $txt);
        $nextStartTag = "";
        preg_match_all('/<strong>(.*?)<\/strong>/ism', $txt, $m);
        foreach($m[0] as $k=>$v) {
            $replace = [];
            $str = trim($m[1][$k]);
            $aa = explode("<br>", $str);
            foreach($aa as $kk=>$vv) {
                $replace[] = "<strong>".trim($vv)."</strong>";
            }
            $txt = strtr($txt, array("<strong>".$str."</strong>" => implode("<br>\n", $replace)));

        }

        $aa = explode("<br>", $txt);
        $nextStartTag = "";
        preg_match_all('/<em>(.*?)<\/em>/ism', $txt, $m);
        foreach($m[0] as $k=>$v) {
            $replace = [];
            $str = trim($m[1][$k]);
            $aa = explode("<br>", $str);
            foreach($aa as $kk=>$vv) {
                $replace[] = "<em>".trim($vv)."</em>";
            }
            $txt = strtr($txt, array("<em>".$str."</em>" => implode("<br>\n", $replace)));
        }

        $aa = explode("<br>", $txt);
        $nextStartTag = "";
        preg_match_all('/<span style="text-decoration: underline;">(.*?)<\/span>/ism', $txt, $m);
        foreach($m[0] as $k=>$v) {
            $replace = [];
            $str = trim($m[1][$k]);
            $aa = explode("<br>", $str);
            foreach($aa as $kk=>$vv) {
                $replace[] = "<span style=\"text-decoration: underline;\">".trim($vv)."</span>";
            }
            $txt = strtr($txt, array("<span style=\"text-decoration: underline;\">".$str."</span>" => implode("<br>\n", $replace)));
        }

        $aa = explode("<br>", $txt);

        $txt2 = array();
        $tmp = array();
        foreach($aa as $k => $line) {
            $line = trim($line, "\r\n");
            $txt2[] = bUtil::completionHTML($line);
        }
        $record['type_text'] = implode("<br>", $txt2);
        //空ラグは除去
        $record['type_text'] = strtr($record['type_text'], array(
            '<i></i>'=>'',
            '<strong></strong>'=>'',
            '<em></em>'=>'',
            '<span style="text-decoration: underline;"></span>'=>'',
        ));
        $record['type_text'] = preg_replace('/(.*)<br>$/smi', "$1", $record['type_text']);


        $this->db->query('BEGIN');
        //保存処理開始
        if (is_array($old_data) && count($old_data) > 0) {
            //更新
            if (!$this->db->update($this->getTbl(), $record, 'pageu_code='.$record['pageu_code'])) {
                $this->db->query('ROLLBACK');

                return _gettext('B_P00209');
            }
        } else {
            //新規
            if (!$this->db->insert($this->getTbl(), $record)) {
                $this->db->query('ROLLBACK');

                return _gettext('B_P00209');
            }
        }
        $this->db->query('COMMIT');

        return;
    }
}
